<template>
  <el-dialog
    width="30%"
    title="Edit Category"
    :visible="dialogvisible"
    append-to-body
    @close="$emit('update:dialogvisible', false)"
  >
    <el-form
      id="edit-form"
      :model="content"
      :rules="rules"
      ref="content"
      label-width="120px"
      class="demo-content"
      v-if="content"
      v-loading="loading"
    >
      <el-form-item
        label="Name"
        prop="categoryName"
      >
        <el-input v-model="content.categoryName"></el-input>
      </el-form-item>

      <!--<el-form-item label="Created At" style="margin-bottom: 5px">-->
      <!--<el-input>{{ content.created_at | moment("calendar", "July 10 2011") }}</el-input>-->
      <!--&lt;!&ndash;<span></span>&ndash;&gt;-->
      <!--</el-form-item>-->
      <!--<el-form-item label="Update At">-->
      <!--<el-input >{{content.updated_at | moment("calendar", "July 10 2011")}}</el-input>-->
      <!--&lt;!&ndash;<span>{{content.updated_at | moment("calendar", "July 10 2011")}}</span>&ndash;&gt;-->
      <!--</el-form-item>-->

      <div>
        <div class="btn-left">
          <el-button
            class="text-red"
            type="text"
            @click="onRemove(detail.id, $event)"
          >Delete
          </el-button>
        </div>
        <div class="btn-right">
          <el-button
            type="primary"
            @click="submitForm('content')"
            :disabled="loading"
            icon="mdi mdi-content-save-outline"
          >Save changes</el-button>
        </div>

      </div>
    </el-form>

  </el-dialog>

</template>
<script>
import $ from 'jquery'
import { category as categoryAPI, media as mediaAPI } from '~/services/apis/index';

export default {
  props: ['dialogvisible', 'detail', "list"],
  data () {
    return {
      rules: {
        categoryName: [
          { required: true, message: 'Please input Category name', trigger: 'blur' },
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],
        position: [
          { validator: this.$helper.validateNumber, trigger: 'blur' }
        ]
      },
      fileList: [

      ],
      content: {
        categoryName: "",
        id: "",
      },
      loading: false,
      imageName: "",
      updateIcon: false,
      file: null,
    };
  },
  methods: {
    submitForm (formName) {
      if (!this.$refs[formName]) return false;
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.loading = true;
          this.submit();
        } else {
          this.loading = false;
          return false;
        }
      });
    },
    resetForm (formName) {
      if (!this.$refs[formName]) return;
      this.$refs[formName].resetFields();
      this.content.name = "";
      this.removeImg();
    },
    onRemoveImg (e) {
      e.preventDefault();
      e.stopPropagation();
      this.removeImg();
    },
    removeImg () {
      this.imageName = "";
      this.file = null;
      this.updateIcon = true;
      this.content.icon_url = "";
    },

    submit () {
      this.loading = true
      categoryAPI.updateCategory(this.content)
        .then((res) => {
          this.$parent.getListData();
          this.loading = false;
          this.$notify({
            title: 'Success',
            message: 'Update category successfully!',
            type: 'success'
          });
          this.$emit('update:dialogvisible', false);
        })
        .catch((err) => {
          this.loading = false;
          this.$notify.error({
            title: 'Error',
            message: 'Cannot edit category'
          });
          this.$emit('update:dialogvisible', false);
        })
    },
    getDetail () {
      return {
        categoryName: this.detail.categoryName,
        id: this.detail.id,
      };
    },
    onChangeIcon (file, fileList) {
      if (!file) return;

      this.imageName = file.name;
      this.content.icon_url = URL.createObjectURL(file.raw);
      this.file = file.raw;
      this.updateIcon = true;
    },
    resetDialog () {
      this.resetForm("content");
    },
    onRemove () {
      console.log(this.content.id);
      this.$confirm('Are you sure you want to delete item?', 'Warning', {
        confirmButtonText: 'Yes',
        cancelButtonText: 'Cancel',
        type: 'warning',
        center: true
      }).then(() => {
        this.loading = true;
        categoryAPI.removeCategory(this.content.id)
          .then((res) => {
            this.$notify({
              title: 'Success',
              message: 'Delete category successfully!',
              type: 'success'
            });

            this.$emit('update:dialogvisible', false);
            this.list.splice(this.detail.index, 1);
            this.loading = false;
          })

          .catch(() => {
            this.$notify.error({
              title: 'Error',
              message: 'Cannot delete category'
            });
            this.loading = false;
          })
      }).catch((err) => {
        console.log(err);
      });

    }
  },
  mounted () {
    //eslint-disable-next-line
    console.log('this.detail :', this.detail);
    let that = this;
    $('body').on("submit", "#edit-form", function (e) {
      event.preventDefault();
      that.submitForm('content');
    });
  },
  watch: {
    detail: function () {

    },
    dialogvisible: function () {
      this.resetDialog();
      this.content = this.getDetail();
      this.imageName = "";
      this.updateIcon = false;
      this.loading = false;
    }
  },

}
</script>

<style lang="scss">
.upload-img-outer {
  position: relative;
  .icon-img-close {
    position: absolute;
    top: 3px;
    right: 5px;
    padding: 3px !important;

    &:hover {
    }
  }
}
</style>
